const request = uni.$u.http

//获取地区{{host}}/api/index/all_region
export function allRegion(params) {
	return request.get(
		`index/all_region`, {
			params
		}
	)
}


// 隐私协议
export function myLogin(data) {
	return request.post(
		`auth/mnplogin`,
		data
	)
}

export function joinVip(data) {
	return request.post(
		`v1/user/userJoinVip`,
		data
	)
}

export function update(data) {
	return request.post(
		`users/1/update_avatar_nickname`,
		data
	)
}

//用户加入会员{{host}}/api/v1/user/
export function userJoinVip(data) {
	return request.post(
		`v1/user/userJoinVip`,
		data
	)
}

//消息获取
export function messageList(data) {
	return request.post(
		`/v1/message/messageList`,
		data
	)
}

//更新用户信息
export function refreshPersonData(data) {
	return request.post(
		`v1/user/updateUser`,
		data
	)
}

//用户信息
export function userInfo(data) {
	return request.post(
		`v1/user/userInfo`,
		data
	)
}
//新增用户数据
export function userMemberAdd(data) {
	return request.post(
		`users/member_add`,
		data
	)
}

//上传图片
export function UserUploadFile(data) {
	return request.post(
		`v1/user/uploadFile`,
		data
	)
}

//删除信息
export function delMessage(data) {
	return request.post(
		`v1/message/delMessage`,
		data
	)
}


//用户访问
export function userVisits(data) {
	return request.post(
		`users/visits`,
		data
	)
}




export default {
	allRegion,
	myLogin,
	update,
	joinVip,
	userJoinVip,
	messageList,
	refreshPersonData,
	userInfo,
	userMemberAdd,
	UserUploadFile,
	delMessage,
	userVisits
}
