import App from './App'

// #ifndef VUE3
import Vue from 'vue'
import uView from "uview-ui";
// vuex store
import store from './store'
import mixin from './utils/mixin'
import tools from './utils/tools'
let mpShare = require('uview-ui/libs/mixin/mpShare.js');
Vue.mixin(mpShare)
// Vue.prototype.$store = store
Vue.use(uView);
Vue.mixin(mixin)

Vue.config.productionTip = false

Vue.prototype.$utils = {
	...tools
}

App.mpType = 'app'
const app = new Vue({
	store,
    ...App
})
require('utils/request/index')(app)
app.$mount()
// #endif

// #ifdef VUE3
import { createSSRApp } from 'vue'
export function createApp() {
  const app = createSSRApp(App)
  return {
    app
  }
}
// #endif